﻿/*
 * Created by toText.net.
 * Date: 10/02/2009
 * 
 */
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Receive
{
	/// <summary>
	/// Form used for reception and display of message reply data from toText.net.
	/// </summary>
	public class ReceiveForm : Page
	{	
		//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		#region Data

		protected TextBox mobileNoReceived;
		protected TextBox timestampReceived;
		protected TextBox messageReceived;

		private const string MOBILE_NO_API_STRING = "mobileNumber";
		private const string TIMESTAMP_API_STRING = "dateAndTime";
		private const string MESSAGE_API_STRING = "message";
		private const string REFERENCE_API_STRING = "reference";
		private const string SENDER_ID_API_STRING = "senderLabel";
		#endregion
		//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		#region Page Init & Exit (Open/Close DB connections here...)

		protected void PageInit(object sender, EventArgs e)
		{
		}
		//----------------------------------------------------------------------
		protected void PageExit(object sender, EventArgs e)
		{
		}

		#endregion
		//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		#region Page Load
		private void Page_Load(object sender, EventArgs e)
		{
			//------------------------------------------------------------------
			if(IsPostBack)
			{
			}
			//------------------------------------------------------------------
			//Extract any data out from the request string sent by toText.net
			UpdateApplicationStorage(MOBILE_NO_API_STRING);
			UpdateApplicationStorage(TIMESTAMP_API_STRING);
			UpdateApplicationStorage(MESSAGE_API_STRING);
			UpdateApplicationStorage(REFERENCE_API_STRING);
			UpdateApplicationStorage(SENDER_ID_API_STRING);
			
			//Populate the controls with the data.
			UpdateControlFromStorageData(mobileNoReceived, MOBILE_NO_API_STRING);
			UpdateControlFromStorageData(timestampReceived, TIMESTAMP_API_STRING);
			UpdateControlFromStorageData(messageReceived, MESSAGE_API_STRING);
			
		}
		#endregion
		//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		#region Private Methods
		/// <summary>
		/// Updates application data from data received from the toText.net API.
		/// </summary>
		/// <param name="apiString">The string identifying the parameter</param>
		private void UpdateApplicationStorage(string apiString)
		{
			if (Request[apiString] != null)
			{
				Application[apiString] = Request[apiString].ToString();
			}
			else
			{
				Application[apiString] = null;
			}
		}
		
		/// <summary>
		/// Updates a textbox from storage data.
		/// </summary>
		/// <param name="textboxToUpdate">The textbox to populate</param>
		/// <param name="apiString">The string identifying the stored data</param>
		private void UpdateControlFromStorageData(TextBox textboxToUpdate, string apiString)
		{
			if (Application[apiString] != null)
			{
				textboxToUpdate.Text = Application[apiString].ToString();
			}
			else
			{
				textboxToUpdate.Text = "";
			}
		}
		#endregion Private Methods
		//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		#region Initialize Component

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		//----------------------------------------------------------------------
		private void InitializeComponent()
		{
			this.Load	+= new System.EventHandler(Page_Load);
			this.Init   += new System.EventHandler(PageInit);
			this.Unload += new System.EventHandler(PageExit);
			
		}
		#endregion
		//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	}
}